-- Fredzaza/Brundavo --

GodetECR88 = {};

function GodetECR88.prerequisitesPresent(specializations)
      return true;
end;
function GodetECR88.initSpecialization()
end
function GodetECR88.registerOverwrittenFunctions(vehicleType)
end
function GodetECR88.registerFunctions(vehicleType)	
end
function GodetECR88.registerEvents(vehicleType)
end
function GodetECR88:registerActionEventsPlayer()
end
function GodetECR88:registerActionEventsMenu()
end

function GodetECR88:onRegisterActionEvents(isSelected, isOnActiveVehicle)
	if isOnActiveVehicle then
		if self.GodetECR88 == nil then 
			self.GodetECR88 = {}
		else	
			self:clearActionEventsTable( self.GodetECR88 )
		end 
		for _,actionName in pairs({"col_ecr88_v1"}) do
			local _, eventName = self:addActionEvent(self.GodetECR88, InputAction[actionName], self, GodetECR88.actionCallback, true, true, false, true, nil);
	
			if isSelected then
				g_inputBinding.events[eventName].displayPriority = 1
			end
		end
	end
end

function GodetECR88.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", GodetECR88)
	SpecializationUtil.registerEventListener(vehicleType, "onDelete", GodetECR88)
    SpecializationUtil.registerEventListener(vehicleType, "onReadStream", GodetECR88)
    SpecializationUtil.registerEventListener(vehicleType, "onWriteStream", GodetECR88)
    --SpecializationUtil.registerEventListener(vehicleType, "onReadUpdateStream", GodetECR88)
    --SpecializationUtil.registerEventListener(vehicleType, "onWriteUpdateStream", GodetECR88)
	SpecializationUtil.registerEventListener(vehicleType, "onUpdate", GodetECR88)
	SpecializationUtil.registerEventListener(vehicleType, "onDeactivate", GodetECR88)
	SpecializationUtil.registerEventListener(vehicleType, "onDraw", GodetECR88)
	SpecializationUtil.registerEventListener(vehicleType, "onRegisterActionEvents", GodetECR88)
end

function GodetECR88:onLoad(vehicle)	
	self.animcol = GodetECR88.animcol
	self.collision = false

	self.racine2 = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.objet#index"));
	self.godetvisual = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.godetvisual#index"));
end;

function GodetECR88:onDelete() 
end;

function GodetECR88:onReadStream(streamId, connection)
    local collision = streamReadBool(streamId)
    self:animcol(collision, true)
end;
  
function GodetECR88:onWriteStream(streamId, connection)
    streamWriteBool(streamId, self.collision)
end;

function GodetECR88:mouseEvent(posX, posY, isDown, isUp, button)
end;

function GodetECR88:keyEvent(unicode, sym, modifier, isDown)    
end;

function GodetECR88:onUpdate(dt, vehicle)
		local attacherVehicle = self:getAttacherVehicle()
		if attacherVehicle ~= nil then
			if attacherVehicle.godetvisualpelle ~= nil then
				link(attacherVehicle.godetvisualpelle, self.godetvisual)
			end
		else
			unlink(self.godetvisual)
			link(self.racine2, self.godetvisual)
        end
end;

function GodetECR88:onUpdateTick() 
end;	
function GodetECR88:onDeactivate()
	unlink(self.godetvisual)
	link(self.racine2, self.godetvisual)
end;       
function GodetECR88:onDraw()  
end;

function GodetECR88:actionCallback(actionName, keyStatus, arg4, arg5, arg6)
	if keyStatus > 0 then
		if actionName == 'col_ecr88_v1' then
			if self.collision then
				self:animcol(false)
			else 
				self:animcol(true)
			end
		end
	end
end

function GodetECR88:animcol(collision, noEventSend)
	AnimcolEvent.sendEvent(self, collision, noEventSend)
	self.collision = collision;
		if self.collision then
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("colisiongodet", 1, nil, true)
			end
		else
			for name,_ in pairs(self.spec_animatedVehicle.animations) do
				self:playAnimation("colisiongodet", -1, nil, true)
			end
		end;
end;

--- Event ---

AnimcolEvent = {};
AnimcolEvent_mt = Class(AnimcolEvent, Event);
InitEventClass(AnimcolEvent, "AnimcolEvent");

function AnimcolEvent:emptyNew()
    local self = Event:new(AnimcolEvent_mt);
    return self;
end;
function AnimcolEvent:new(object, collision)
	local self = AnimcolEvent:emptyNew()
	self.object = object;
	self.collision = collision;
	return self;
end;
function AnimcolEvent:readStream(streamId, connection)
	self.object = NetworkUtil.readNodeObject(streamId);
	self.collision = streamReadBool(streamId);
	self:run(connection);
end;
function AnimcolEvent:writeStream(streamId, connection)
	NetworkUtil.writeNodeObject(streamId, self.object);
	streamWriteBool(streamId, self.collision);
end;
function AnimcolEvent:run(connection)
	if not connection:getIsServer() then
		g_server:broadcastEvent(self, false, connection, self.object);
	end;
	if self.object ~= nil then
		self.object:animcol(self.collision, true);
	end;
end;
function AnimcolEvent.sendEvent(vehicle, collision, noEventSend)
	if collision ~= vehicle.collision then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(AnimcolEvent:new(vehicle, collision), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(AnimcolEvent:new(vehicle, collision));
			end;
		end;
	end;
end;