-- Fredzaza --

TerraTrac = {};

function TerraTrac.prerequisitesPresent(specializations)
      return true;
end;
function TerraTrac.initSpecialization()
end
function TerraTrac.registerOverwrittenFunctions(vehicleType)
end
function TerraTrac.registerFunctions(vehicleType)	
end
function TerraTrac.registerEvents(vehicleType)
end
function TerraTrac:registerActionEventsPlayer()
end
function TerraTrac:registerActionEventsMenu()
end

function TerraTrac:onRegisterActionEvents(isSelected, isOnActiveVehicle)
end

function TerraTrac.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", TerraTrac)
	SpecializationUtil.registerEventListener(vehicleType, "onDelete", TerraTrac)
    SpecializationUtil.registerEventListener(vehicleType, "onReadStream", TerraTrac)
    SpecializationUtil.registerEventListener(vehicleType, "onWriteStream", TerraTrac)
    --SpecializationUtil.registerEventListener(vehicleType, "onReadUpdateStream", TerraTrac)
    --SpecializationUtil.registerEventListener(vehicleType, "onWriteUpdateStream", TerraTrac)
	SpecializationUtil.registerEventListener(vehicleType, "onUpdate", TerraTrac)
	SpecializationUtil.registerEventListener(vehicleType, "onDraw", TerraTrac)
	SpecializationUtil.registerEventListener(vehicleType, "onRegisterActionEvents", TerraTrac)

end

function TerraTrac:onLoad(vehicle)	
	self.indexTracRight = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.TracWheelsRight#index"));    
    self.charIdAnimR = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.TracWheelsRight#node"));
    self.clipIndexAnimR = getXMLString(self.xmlFile, "vehicle.TracWheelsRight#animationClip");
    self.spedR = Utils.getNoNil(getXMLInt(self.xmlFile, "vehicle.TracWheelsRight#sped"))
    self.TracWheelsRight = {}
    local i = 0
    while true do
        local baseName = string.format("vehicle.TracWheelsRight.rotatingPart(%d)", i)
        local index = getXMLString(self.xmlFile, baseName .. "#index")
        if index == nil then
            break
        end
        local node = I3DUtil.indexToObject(self.components, index)
        if node ~= nil then
            local entry = {}
            entry.node = node
            entry.speedScale = getXMLFloat(self.xmlFile, baseName .. "#speedScale")
            if entry.speedScale == nil then
                entry.speedScale = 1 / Utils.getNoNil(getXMLFloat(self.xmlFile, baseName .. "#radius"), 1)
            end
            table.insert(self.TracWheelsRight, entry)
        end
        i = i + 1        
    end
    
    self.indexTracLeft = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.TracWheelsLeft#index"));    
    self.charIdAnimL = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.TracWheelsLeft#node"));
    self.clipIndexAnimL = getXMLString(self.xmlFile, "vehicle.TracWheelsLeft#animationClip");
    self.spedL = Utils.getNoNil(getXMLInt(self.xmlFile, "vehicle.TracWheelsLeft#sped"))        
    self.TracWheelsLeft = {}
    local i = 0
    while true do
        local baseName = string.format("vehicle.TracWheelsLeft.rotatingPart(%d)", i)
        local index = getXMLString(self.xmlFile, baseName .. "#index")
        if index == nil then
            break
        end
        local node = I3DUtil.indexToObject(self.components, index)
        if node ~= nil then
            local entry = {}
            entry.node = node
            entry.speedScale = getXMLFloat(self.xmlFile, baseName .. "#speedScale")
            if entry.speedScale == nil then
                entry.speedScale = 1 / Utils.getNoNil(getXMLFloat(self.xmlFile, baseName .. "#radius"), 1)
            end
            table.insert(self.TracWheelsLeft, entry)
        end
        i = i + 1        
    end	
end;

function TerraTrac:onDelete() 
end;

function TerraTrac:onReadStream(streamId, connection)
end;
  
function TerraTrac:onWriteStream(streamId, connection)
end;

function TerraTrac:mouseEvent(posX, posY, isDown, isUp, button)
end;

function TerraTrac:keyEvent(unicode, sym, modifier, isDown)    
end;

function TerraTrac:onUpdate(dt, vehicle)
	local spece = self.spec_motorized
	if spece.isMotorStarted then	
        local newX1, newY1, newZ1 = getWorldTranslation(self.indexTracLeft);
        if self.lastTranslationL == nil then
            self.lastTranslationL = {newX1, newY1, newZ1};
        end;
        local dx1, dy1, dz1 = worldDirectionToLocal(self.indexTracLeft, newX1-self.lastTranslationL[1], newY1-self.lastTranslationL[2], newZ1-self.lastTranslationL[3]);
        local movingDirectionL = 0
		local lastSpeedL = spece:getLastSpeed()

        if lastSpeedL > 0.0001 then    
            if dz1 < 0.0001 then
                movingDirectionL = -1;
            elseif dz1 > 0.0001 then
                movingDirectionL = 1;    
            end;
        end;    
	    local lastMovedDistanceL = MathUtil.vector3Length(dx1, dy1, dz1) ;
        self.lastTranslationL[1] = newX1
        self.lastTranslationL[2] = newY1
        self.lastTranslationL[3] = newZ1

        local charIdL = getAnimCharacterSet(self.charIdAnimL);
        local clipIndexL = getAnimClipIndex(charIdL, self.clipIndexAnimL);
    
        assignAnimTrackClip(charIdL , 0, clipIndexL);
        setAnimTrackLoopState(charIdL, 0, true);
        setAnimTrackSpeedScale(charIdL, 0, self.spedL*lastMovedDistanceL*movingDirectionL);
        enableAnimTrack(charIdL, 0);
		
		for _, v in pairs(self.TracWheelsLeft) do
            rotate(v.node, v.speedScale * lastMovedDistanceL*movingDirectionL, 0, 0)
        end   
		
		local newX2, newY2, newZ2 = getWorldTranslation(self.indexTracRight);
        if self.lastTranslationR == nil then
            self.lastTranslationR = {newX2, newY2, newZ2};
        end;
        local dx2, dy2, dz2 = worldDirectionToLocal(self.indexTracRight, newX2-self.lastTranslationR[1], newY2-self.lastTranslationR[2], newZ2-self.lastTranslationR[3]);
        local movingDirectionR = 0
		local lastSpeedR = spece:getLastSpeed()
        if lastSpeedR > 0.0001 then    
            if dz2 < 0.0001 then
                movingDirectionR = -1;
            elseif dz2 > 0.0001 then
                movingDirectionR = 1;        
            end;
        end;    
        local lastMovedDistanceR = MathUtil.vector3Length(dx2, dy2, dz2);    
        self.lastTranslationR[1] = newX2
        self.lastTranslationR[2] = newY2
        self.lastTranslationR[3] = newZ2    
        
        local charIdR = getAnimCharacterSet(self.charIdAnimR);
        local clipIndexR = getAnimClipIndex(charIdR, self.clipIndexAnimR);        

        assignAnimTrackClip(charIdR , 0, clipIndexR);
        setAnimTrackLoopState(charIdR, 0, true);
        setAnimTrackSpeedScale(charIdR, 0, self.spedR*lastMovedDistanceR*movingDirectionR);
        enableAnimTrack(charIdR, 0);
		
		for _, v in pairs(self.TracWheelsRight) do
            rotate(v.node, v.speedScale * lastMovedDistanceR*movingDirectionR, 0, 0)
        end; 
	end;

	
end;

function TerraTrac:onUpdateTick() 
end;	
function TerraTrac:onLeaveVehicle()
end;       
function TerraTrac:onDraw()  
end;

function TerraTrac:actionCallback(actionName, keyStatus, arg4, arg5, arg6)
end
